# coding: utf-8

"""
    ****************************************************************************
    Copyright (c) 2016-present,
    Jaguar0625, gimre, BloodyRookie, Tech Bureau, Corp. All rights reserved.

    This file is part of Catapult.

    Catapult is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Catapult is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Catapult. If not, see <http://www.gnu.org/licenses/>.
    ****************************************************************************
    
    Catapult REST Endpoints
    OpenAPI Specification of catapult-rest 2.3.0  # noqa: E501
    The version of the OpenAPI document: 0.11.2
    Contact: contact@nem.foundation

    NOTE: This file is auto generated by Symbol OpenAPI Generator:
    https://github.com/nemtech/symbol-openapi-generator
    Do not edit this file manually.
"""


import pprint
import re  # noqa: F401

import six

from symbol_openapi_client.configuration import Configuration


class ImportanceBlockDTOAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'voting_eligible_accounts_count': 'int',
        'harvesting_eligible_accounts_count': 'str',
        'total_voting_balance': 'str',
        'previous_importance_block_hash': 'str'
    }

    attribute_map = {
        'voting_eligible_accounts_count': 'votingEligibleAccountsCount',
        'harvesting_eligible_accounts_count': 'harvestingEligibleAccountsCount',
        'total_voting_balance': 'totalVotingBalance',
        'previous_importance_block_hash': 'previousImportanceBlockHash'
    }

    def __init__(self, voting_eligible_accounts_count=None, harvesting_eligible_accounts_count=None, total_voting_balance=None, previous_importance_block_hash=None, local_vars_configuration=None):  # noqa: E501
        """ImportanceBlockDTOAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._voting_eligible_accounts_count = None
        self._harvesting_eligible_accounts_count = None
        self._total_voting_balance = None
        self._previous_importance_block_hash = None
        self.discriminator = None

        self.voting_eligible_accounts_count = voting_eligible_accounts_count
        self.harvesting_eligible_accounts_count = harvesting_eligible_accounts_count
        self.total_voting_balance = total_voting_balance
        self.previous_importance_block_hash = previous_importance_block_hash

    @property
    def voting_eligible_accounts_count(self):
        """Gets the voting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501

        A number that allows uint 32 values.  # noqa: E501

        :return: The voting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501
        :rtype: int
        """
        return self._voting_eligible_accounts_count

    @voting_eligible_accounts_count.setter
    def voting_eligible_accounts_count(self, voting_eligible_accounts_count):
        """Sets the voting_eligible_accounts_count of this ImportanceBlockDTOAllOf.

        A number that allows uint 32 values.  # noqa: E501

        :param voting_eligible_accounts_count: The voting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and voting_eligible_accounts_count is None:  # noqa: E501
            raise ValueError("Invalid value for `voting_eligible_accounts_count`, must not be `None`")  # noqa: E501

        self._voting_eligible_accounts_count = voting_eligible_accounts_count

    @property
    def harvesting_eligible_accounts_count(self):
        """Gets the harvesting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501

        A number that allows uint 64 values represented with a string.  # noqa: E501

        :return: The harvesting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501
        :rtype: str
        """
        return self._harvesting_eligible_accounts_count

    @harvesting_eligible_accounts_count.setter
    def harvesting_eligible_accounts_count(self, harvesting_eligible_accounts_count):
        """Sets the harvesting_eligible_accounts_count of this ImportanceBlockDTOAllOf.

        A number that allows uint 64 values represented with a string.  # noqa: E501

        :param harvesting_eligible_accounts_count: The harvesting_eligible_accounts_count of this ImportanceBlockDTOAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and harvesting_eligible_accounts_count is None:  # noqa: E501
            raise ValueError("Invalid value for `harvesting_eligible_accounts_count`, must not be `None`")  # noqa: E501

        self._harvesting_eligible_accounts_count = harvesting_eligible_accounts_count

    @property
    def total_voting_balance(self):
        """Gets the total_voting_balance of this ImportanceBlockDTOAllOf.  # noqa: E501

        Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).  # noqa: E501

        :return: The total_voting_balance of this ImportanceBlockDTOAllOf.  # noqa: E501
        :rtype: str
        """
        return self._total_voting_balance

    @total_voting_balance.setter
    def total_voting_balance(self, total_voting_balance):
        """Sets the total_voting_balance of this ImportanceBlockDTOAllOf.

        Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).  # noqa: E501

        :param total_voting_balance: The total_voting_balance of this ImportanceBlockDTOAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and total_voting_balance is None:  # noqa: E501
            raise ValueError("Invalid value for `total_voting_balance`, must not be `None`")  # noqa: E501

        self._total_voting_balance = total_voting_balance

    @property
    def previous_importance_block_hash(self):
        """Gets the previous_importance_block_hash of this ImportanceBlockDTOAllOf.  # noqa: E501


        :return: The previous_importance_block_hash of this ImportanceBlockDTOAllOf.  # noqa: E501
        :rtype: str
        """
        return self._previous_importance_block_hash

    @previous_importance_block_hash.setter
    def previous_importance_block_hash(self, previous_importance_block_hash):
        """Sets the previous_importance_block_hash of this ImportanceBlockDTOAllOf.


        :param previous_importance_block_hash: The previous_importance_block_hash of this ImportanceBlockDTOAllOf.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and previous_importance_block_hash is None:  # noqa: E501
            raise ValueError("Invalid value for `previous_importance_block_hash`, must not be `None`")  # noqa: E501

        self._previous_importance_block_hash = previous_importance_block_hash

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ImportanceBlockDTOAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ImportanceBlockDTOAllOf):
            return True

        return self.to_dict() != other.to_dict()
